diff --git a/test/test/test_flow_classify.c b/test/test/test_flow_classify.c
index fc83b69ae..2ff1ca831 100644
--- a/test/test/test_flow_classify.c
+++ b/test/test/test_flow_classify.c
@@ -231,7 +231,7 @@ test_invalid_parameters(void)
 		printf("Line %i: rte_flow_classify_validate",
 			__LINE__);
 		printf(" with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(NULL, NULL, NULL, NULL,
@@ -239,7 +239,7 @@ test_invalid_parameters(void)
 	if (rule) {
 		printf("Line %i: flow_classifier_table_entry_add", __LINE__);
 		printf(" with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(NULL, NULL);
@@ -247,14 +247,14 @@ test_invalid_parameters(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classifier_query(NULL, NULL, 0, NULL, NULL);
 	if (!ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(NULL, NULL, NULL, NULL,
@@ -262,7 +262,7 @@ test_invalid_parameters(void)
 	if (rule) {
 		printf("Line %i: flow_classify_table_entry_add ", __LINE__);
 		printf("with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(NULL, NULL);
@@ -270,16 +270,16 @@ test_invalid_parameters(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf("with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classifier_query(NULL, NULL, 0, NULL, NULL);
 	if (!ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" with NULL param should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -310,7 +310,7 @@ test_valid_parameters(void)
 		printf("Line %i: rte_flow_classify_validate",
 			__LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
 			actions, &key_found, &error);
@@ -318,7 +318,7 @@ test_valid_parameters(void)
 	if (!rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -326,9 +326,9 @@ test_valid_parameters(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -361,7 +361,7 @@ test_invalid_patterns(void)
 	if (!ret) {
 		printf("Line %i: rte_flow_classify_validate", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -369,7 +369,7 @@ test_invalid_patterns(void)
 	if (rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -377,7 +377,7 @@ test_invalid_patterns(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	pattern[1] = ipv4_udp_item_1;
@@ -389,7 +389,7 @@ test_invalid_patterns(void)
 	if (!ret) {
 		printf("Line %i: rte_flow_classify_validate", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -397,7 +397,7 @@ test_invalid_patterns(void)
 	if (rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -405,9 +405,9 @@ test_invalid_patterns(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -437,7 +437,7 @@ test_invalid_actions(void)
 	if (!ret) {
 		printf("Line %i: rte_flow_classify_validate", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -445,7 +445,7 @@ test_invalid_actions(void)
 	if (rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -453,7 +453,7 @@ test_invalid_actions(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	actions[0] = count_action;
@@ -464,7 +464,7 @@ test_invalid_actions(void)
 	if (!ret) {
 		printf("Line %i: rte_flow_classify_validate", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -472,7 +472,7 @@ test_invalid_actions(void)
 	if (rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -480,9 +480,9 @@ test_invalid_actions(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf("should have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -628,7 +628,7 @@ init_mbufpool(void)
 			} else {
 				printf("Cannot init mbuf pool on socket %d\n",
 					socketid);
-				ret = -ENOMEM;
+				ret = TEST_FAILED;
 				break;
 			}
 		}
@@ -649,7 +649,7 @@ test_query_udp(void)
 	if (ret != MAX_PKT_BURST) {
 		printf("Line %i: init_udp_ipv4_traffic has failed!\n",
 				__LINE__);
-		return -1;
+		return TEST_FAILED;
 	}
 
 	for (i = 0; i < MAX_PKT_BURST; i++)
@@ -675,7 +675,7 @@ test_query_udp(void)
 	if (ret) {
 		printf("Line %i: rte_flow_classify_validate", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -683,7 +683,7 @@ test_query_udp(void)
 	if (!rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classifier_query(cls->cls, bufs, MAX_PKT_BURST,
@@ -691,7 +691,7 @@ test_query_udp(void)
 	if (ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -699,9 +699,9 @@ test_query_udp(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -716,7 +716,7 @@ test_query_tcp(void)
 	if (ret != MAX_PKT_BURST) {
 		printf("Line %i: init_ipv4_tcp_traffic has failed!\n",
 				__LINE__);
-		return -1;
+		return TEST_FAILED;
 	}
 
 	for (i = 0; i < MAX_PKT_BURST; i++)
@@ -742,7 +742,7 @@ test_query_tcp(void)
 	if (ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -750,7 +750,7 @@ test_query_tcp(void)
 	if (!rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classifier_query(cls->cls, bufs, MAX_PKT_BURST,
@@ -758,7 +758,7 @@ test_query_tcp(void)
 	if (ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -766,9 +766,9 @@ test_query_tcp(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -783,7 +783,7 @@ test_query_sctp(void)
 	if (ret != MAX_PKT_BURST) {
 		printf("Line %i: init_ipv4_tcp_traffic has failed!\n",
 			__LINE__);
-		return -1;
+		return TEST_FAILED;
 	}
 
 	for (i = 0; i < MAX_PKT_BURST; i++)
@@ -809,7 +809,7 @@ test_query_sctp(void)
 	if (ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	rule = rte_flow_classify_table_entry_add(cls->cls, &attr, pattern,
@@ -817,7 +817,7 @@ test_query_sctp(void)
 	if (!rule) {
 		printf("Line %i: flow_classify_table_entry_add", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classifier_query(cls->cls, bufs, MAX_PKT_BURST,
@@ -825,7 +825,7 @@ test_query_sctp(void)
 	if (ret) {
 		printf("Line %i: flow_classifier_query", __LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
 
 	ret = rte_flow_classify_table_entry_delete(cls->cls, rule);
@@ -833,9 +833,9 @@ test_query_sctp(void)
 		printf("Line %i: rte_flow_classify_table_entry_delete",
 			__LINE__);
 		printf(" should not have failed!\n");
-		return -1;
+		return TEST_FAILED;
 	}
-	return 0;
+	return TEST_SUCCESS;
 }
 
 static int
@@ -871,32 +871,32 @@ test_flow_classify(void)
 		printf("Line %i: f_create has failed!\n", __LINE__);
 		rte_flow_classifier_free(cls->cls);
 		rte_free(cls);
-		return -1;
+		return TEST_FAILED;
 	}
 	printf("Created table_acl for for IPv4 five tuple packets\n");
 
 	ret = init_mbufpool();
 	if (ret) {
 		printf("Line %i: init_mbufpool has failed!\n", __LINE__);
-		return -1;
+		return TEST_FAILED;
 	}
 
 	if (test_invalid_parameters() < 0)
-		return -1;
+		return TEST_FAILED;
 	if (test_valid_parameters() < 0)
-		return -1;
+		return TEST_FAILED;
 	if (test_invalid_patterns() < 0)
-		return -1;
+		return TEST_FAILED;
 	if (test_invalid_actions() < 0)
-		return -1;
+		return TEST_FAILED;
 	if (test_query_udp() < 0)
-		return -1;
+		return TEST_FAILED;
 	if (test_query_tcp() < 0)
-		return -1;
+		return TEST_FAILED;
 	if (test_query_sctp() < 0)
-		return -1;
+		return TEST_FAILED;
 
-	return 0;
+	return TEST_SUCCESS;
 }
 
 REGISTER_TEST_COMMAND(flow_classify_autotest, test_flow_classify);